/**
 * JavaScript Admin Functions - postsaver-frontend.min.js
 *
 * @author   Jake Evans
 * @category JavaScript
 * @package  Includes/Assets/Js
 * @version  6.0.0
 */

console.log( 'This is the JavaScript Object that holds all PHP Variables for use in the postsaver Front-End JavaScript file:' );
console.log( postSaverPhpVariables );


// All functions wrapped in jQuery(document ).ready()...
jQuery( document ).ready( function( $ ) {
	'use strict';

	/* BEGINNING SECTION TO CALL ALL FUNCTIONS IN FILE... */

	// Function for manually adding a new user from the front-end. 
    postSaverAddNewUser();

    // Function to reveal a new user's password on the frontend during creation. 
    postSaverSeeNewUserPassword();

    // Function to toggle between the tabs on the logged-in user's dashboard.
    postSaverToggleTabsOnUsersFrontendDashboard();

    // Function to append the save post button to the end of post titles. 
    postSaverAppendSavePostHtml();

    // Function to actually save a post to a Users' account
    postSaverActuallySaveUserPost();

    // Function to auto-click "Saved Posts"
    postSaverAutoClickSavedPosts();

	/* ENDING SECTION TO CALL ALL FUNCTIONS IN FILE... */

    // Function to auto-click "Saved Posts"
    function postSaverAutoClickSavedPosts(){
        if( -1 !== window.location.href.indexOf( '?id=' ) ){
            if( 0 < $( '.postsaverplugin-form-section-wrapper-lefthand-tabs-actual-savedposts' ).length  ){
                $( '.postsaverplugin-form-section-wrapper-lefthand-tabs-actual-savedposts' ).trigger( 'click' );
            }
        }
    }


    // Function to actually save a post to a Users' account
    function postSaverActuallySaveUserPost(){
        $( document ).on( 'click', '.postsaverplugin-save-post-button-div', function( event ) {
            $( this ).find( '.postsaverplugin-spinner' ).animate({'opacity':'1'});
            window.location.href = postSaverPhpVariables.POSTSAVER_FRONTEND_USER_DASHBOARD_SHORTCODE_URL + '?id=' + postSaverPhpVariables.CURRENT_POST_ID;
        });
    }


    // Function to append the save post button to the end of post titles. 
    function postSaverAppendSavePostHtml(){
        var bodyclasses = $('body').attr('class');
        if ( -1 !== bodyclasses.indexOf( 'single-post' ) ){
            if ( '1' === postSaverPhpVariables.IS_USER_LOGGED_IN ) {

                // Get all saved post ids, if any.
                var set_flag = false;
                if ( ( null !== postSaverPhpVariables.USER_SAVED_POST_IDS ) && ( '' !== postSaverPhpVariables.USER_SAVED_POST_IDS ) ) {
                    var ids = postSaverPhpVariables.USER_SAVED_POST_IDS.split( ',' );
                    for (var i = ids.length - 1; i >= 0; i--) {
                        if ( ids[i] == postSaverPhpVariables.CURRENT_POST_ID ) {
                            // User is logged in, and HAS saved this post
                            $( '.entry-title' ).after('<div class="postsaverplugin-save-post-button-top-container"><div class="postsaverplugin-save-post-button-div postsaverplugin-save-post-button-div-loggedin postsaverplugin-save-post-button-div-alreadysaved"><p>You\'ve already saved this post!</p><img src="' + postSaverPhpVariables.POSTSAVER_ROOT_IMG_URL + 'postalreadysaved.png"/><div class="postsaverplugin-spinner"></div></div><div class="postsaverplugin-save-post-response"></div></div>');
                            set_flag = true;
                            break;
                        } 
                    }

                    if ( ! set_flag ) {
                         // User is logged in, and has NOT saved this post
                        $( '.entry-title' ).after('<div class="postsaverplugin-save-post-button-top-container"><div class="postsaverplugin-save-post-button-div postsaverplugin-save-post-button-div-loggedin postsaverplugin-save-post-button-div-loggedin-notsavedthispost"><p>Save This Article!</p><img src="' + postSaverPhpVariables.POSTSAVER_ROOT_IMG_URL + 'savethispost.png"/><div class="postsaverplugin-spinner"></div></div><div class="postsaverplugin-save-post-response"></div></div>');
                    }

                } else {
                    // User is logged in, and has NOT saved ANY posts
                    $( '.entry-title' ).after('<div class="postsaverplugin-save-post-button-top-container"><div class="postsaverplugin-save-post-button-div postsaverplugin-save-post-button-div-loggedin postsaverplugin-save-post-button-div-loggedin-notsavedanyposts"><p>Save This Article!</p><img src="' + postSaverPhpVariables.POSTSAVER_ROOT_IMG_URL + 'savethispost.png"/><div class="postsaverplugin-spinner"></div></div><div class="postsaverplugin-save-post-response"></div></div>');
                }   
            } else {
                // User is NOT logged in at all
                $( '.entry-title' ).after('<div class="postsaverplugin-save-post-button-top-container"><div class="postsaverplugin-save-post-button-div postsaverplugin-save-post-button-div-notloggedin"><a href="' + postSaverPhpVariables.FRONTEND_USER_DASHBOARD_SHORTCODE_URL + '"><p>Save This Article!</p><img src="' + postSaverPhpVariables.POSTSAVER_ROOT_IMG_URL + 'savethispost.png"/></a></div></div>')
            }
        }
    }

    function postSaverCheckPasswordStrength( $pass1, $pass2, $strengthResult, $submitButton, blacklistArray ) {
        var pass1 = $pass1.val();
        var pass2 = $pass2.val();

        // Reset the form & meter
        $strengthResult.css({'opacity':'1'})
        $strengthResult.removeClass( 'short bad good strong' );

        // Extend our blacklist array with those from the inputs & site data
        blacklistArray = blacklistArray.concat( wp.passwordStrength.userInputDisallowedList() )

        // Get the password strength
        var strength = wp.passwordStrength.meter( pass1, blacklistArray, pass2 );

        // Add the strength meter results
        switch ( strength ) {

            case 2:
                $strengthResult.addClass( 'bad' ).html( "Good Password" );
                break;

            case 3:
                $strengthResult.addClass( 'good' ).html( "Great Password!" );
                break;

            case 4:
                $strengthResult.addClass( 'strong' ).html( "Great Password!" );
                break;

            case 5:
                $strengthResult.addClass( 'short' ).html( "Passwords Don't Match!" );
                break;

            default:
                $strengthResult.addClass( 'short' ).html( "Good Password" );

        }

        return strength;
    }

    // Function to reveal a new user's password on the frontend during creation. 
    function postSaverSeeNewUserPassword(){
        $( document ).on( 'click', '#postsaverplugin-form-section-see-new-user-password', function( event ) {
            var visibility = $(this).attr('data-visibility');
            if ( 'hidden' === visibility ) {
                $( '#postsaverplugin-user-password, #postsaverplugin-user-passwordverify' ).attr('type','text');
                $(this).html('Hide Password');
                $(this).attr('data-visibility', 'visible');
            } else {
                $( '#postsaverplugin-user-password, #postsaverplugin-user-passwordverify' ).attr('type','password');
                $(this).html('View Password');
                $(this).attr('data-visibility', 'hidden');
            }  
        });
    }

    // Function to toggle between the tabs on the logged-in user's dashboard.
    function postSaverToggleTabsOnUsersFrontendDashboard(){

        $( document ).on( 'click', '.postsaverplugin-form-section-wrapper-lefthand-tabs-actual-accountinfo', function( event ) {
            $(this).addClass('postsaverplugin-form-section-wrapper-lefthand-tabs-actual-active');
            $('.postsaverplugin-form-section-wrapper-lefthand-tabs-actual-savedposts').removeClass('postsaverplugin-form-section-wrapper-lefthand-tabs-actual-active');
            $( '.postsaverplugin-form-section-wrapper-accountinfo' ).css({'display':'block'});
            $( '.postsaverplugin-form-section-wrapper-savedposts' ).css({'display':'none'});
        });

        $( document ).on( 'click', '.postsaverplugin-form-section-wrapper-lefthand-tabs-actual-savedposts', function( event ) {
            $(this).addClass('postsaverplugin-form-section-wrapper-lefthand-tabs-actual-active');
            $('.postsaverplugin-form-section-wrapper-lefthand-tabs-actual-accountinfo').removeClass('postsaverplugin-form-section-wrapper-lefthand-tabs-actual-active');
            $( '.postsaverplugin-form-section-wrapper-accountinfo' ).css({'display':'none'});
            $( '.postsaverplugin-form-section-wrapper-savedposts' ).css({'display':'block'});
        });
    }
    
    var getUrlParameter = function getUrlParameter(sParam) {
        var sPageURL = window.location.search.substring(1),
            sURLVariables = sPageURL.split('&'),
            sParameterName,
            i;

        for (i = 0; i < sURLVariables.length; i++) {
            sParameterName = sURLVariables[i].split('=');

            if (sParameterName[0] === sParam) {
                return typeof sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
            }
        }
        return false;
    };

    // Function for manually adding a new user from the dashboard. 
    function postSaverAddNewUser(){

        $( document ).on( 'click', '#postsaverplugin-not-registered-top-container input, #postsaverplugin-not-registered-top-container select', function( event ) {
            $( '#postsaverplugin-not-registered-top-container input' ).css({'color':'inherit'});
        });

        // Binding to trigger checkPasswordStrength
        $( 'body' ).on( 'keyup', 'input[name=password], input[name=password_retyped]',
            function( event ) {
                postSaverCheckPasswordStrength(
                    $('input[name=password]'),         // First password field
                    $('input[name=password_retyped]'), // Second password field
                    $('#password-strength'),           // Strength meter
                    $('#postsaverplugin-form-section-add-new-user-button'),           // Submit button
                    ['black', 'listed', 'word']        // Blacklisted words
                );
            }
        );

        
        $( document ).on( 'click', '#postsaverplugin-form-section-add-new-user-button', function( event ) {

            // clear the response div.
            $('.postsaverplugin-response-div-p').text('');

            // Get all the data to add a Student
            var password = $('#postsaverplugin-user-password').val();
            var passwordverify = $('#postsaverplugin-user-passwordverify').val();
            var firstname = $('#postsaverplugin-user-firstname').val();
            var lastname = $('#postsaverplugin-user-lastname').val();
            var email = $('#postsaverplugin-user-email').val();
            var postid = getUrlParameter('id');



            // Make some checks for required data.
            var proceed_flag = true;
            if ( ( '' === email ) || ( null === email ) || ( undefined === email ) ) {
                proceed_flag = false;
                $('#postsaverplugin-response-div-p-new-registrant').text( 'Whoops! Looks like you forgot to provide a valid Email address!' );
                return false;
            }

            if ( ( '' === firstname ) || ( null === firstname ) || ( undefined === firstname ) ) {
                proceed_flag = false;
                $('#postsaverplugin-response-div-p-new-registrant').text( 'Whoops! Looks like you forgot to tell us your name!' );
                return false;
            }


            // Making sure passwords match...
            if ( password !== passwordverify ) {
                proceed_flag = false;
                $('#postsaverplugin-response-div-p-new-registrant').text( 'Whoops! Looks like your passwords don\'t match!' );
                $( '#postsaverplugin-user-password, #postsaverplugin-user-passwordverify' ).css({'color':'red'});
                return false;
            }

            if ( 'Password Strength is...' === $( '#password-strength' ).html() ) {
                proceed_flag = false;
                $('#postsaverplugin-response-div-p-new-registrant').text( 'Whoops! Looks like you forgot to choose a password!' );
                $( '#postsaverplugin-user-password, #postsaverplugin-user-passwordverify' ).css({'color':'red'});
                return false;
            }

            if ( 'Password Strength too low!' === $( '#password-strength' ).html() ) {
                proceed_flag = false;
                $('#postsaverplugin-response-div-p-new-registrant').text( 'Whoops! Please create a stronger password!' );
                $( '#postsaverplugin-user-password, #postsaverplugin-user-passwordverify' ).css({'color':'red'});
                return false;
            }

            if ( proceed_flag ) {

                $('#postsaverplugin-spinner-create').animate({'opacity':'1'});

                // Make Ajax call to get display options.
                var data = {
                    'action': 'postsaver_add_new_user_action',
                    'security': postSaverPhpVariables.adminnonce2,
                    'password': password,
                    'firstname': firstname,
                    'lastname': lastname,
                    'email': email,
                    'postid': postid,
                };

                $.post( postSaverPhpVariables.AJAX_URL, data, function( response ) {

                    $('#postsaverplugin-spinner-create').animate({'opacity':'0'});

                    // Trying to use an already-registered email address or username.
                    if ( 'Whoops! There\'s already a user registered with this Email Address!' === response ) {
                        $('#postsaverplugin-response-div-p-new-registrant').text( response );
                        return false;
                    } else {
                        $('#postsaverplugin-response-div-p-new-registrant').text( 'Success! Please wait while we log you in...' );
                        setTimeout(function(){
                            var baseurl = window.location.href.split( '?' );
                            baseurl = baseurl[0];
                            window.location.href = baseurl + '?un=' + response;
                        }, 3000)
                    }
                });
            }
        });
    }
});
