<?php
/**
 * Postsaverplugin Book Display Options Form Tab Class - class-postsaverplugin-book-display-options-form.php
 *
 * @author   Jake Evans
 * @category Admin
 * @package  Includes/Classes
 * @version  6.1.5.
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Postsaverplugin_Settings1_Form', false ) ) :

	/**
	 * Postsaverplugin_Admin_Menu Class.
	 */
	class Postsaverplugin_Settings1_Form {


		/**
		 * Class Constructor - Simply calls the Translations
		 */
		public function __construct() {

			$this->allpageshtml = '';
			$this->allpagesforblogpagehtml = '';
			$this->allgeneralsettings = array();

			// Calling functions in class now...
			$this->postsaver_get_general_settings();
			$this->postsaver_get_all_pages();
			

		}

		/**
		 * Function to grab all the General Settings and assign them to a class variable.
		 */
		public function postsaver_get_general_settings() {
			global $wpdb;
			$table = $wpdb->prefix . 'postsaver_settings';
			$this->allgeneralsettings = $wpdb->get_row( "SELECT * from $table" );
		}






		/**
		 * Function to build an html list of all pages ona  site, for the user to choose a Dashboard Page from.
		 */
		public function postsaver_get_all_pages() {

			// Get all pages on site.
			$args = array(
			    'sort_order' => 'asc',
			    'sort_column' => 'post_title',
			    'hierarchical' => 1,
			    'post_type' => 'page',
			    'post_status' => 'publish'
			);

			$pages = get_pages( $args ); // get all pages based on supplied args.
			foreach( $pages as $page ){ // $pages is array of object
				
				// To set the Dashboard Page drop-down to the page that has been saved in the DB.
				if( $this->allgeneralsettings->dashboardurl === get_permalink( $page->ID ) ){
					$this->allpageshtml = $this->allpageshtml . '<option selected data-pageid="' . $page->ID . '" value="' . $page->ID . '">' . $page->post_title . '</option>';
				} else {
					$this->allpageshtml = $this->allpageshtml . '<option data-pageid="' . $page->ID . '" value="' . $page->ID . '">' . $page->post_title . '</option>';
				}

				// To set the Blog Page drop-down to the page that has been saved in the DB.
				if( $this->allgeneralsettings->blogpageurl === get_permalink( $page->ID ) ){
					$this->allpagesforblogpagehtml = $this->allpagesforblogpagehtml . '<option selected data-pageid="' . $page->ID . '" value="' . $page->ID . '">' . $page->post_title . '</option>';
				} else {
					$this->allpagesforblogpagehtml = $this->allpagesforblogpagehtml . '<option data-pageid="' . $page->ID . '" value="' . $page->ID . '">' . $page->post_title . '</option>';
				}

			}
		}


		/**
		 * Outputs all HTML elements on the page.
		 */
		public function output_settings1_form() {
			global $wpdb;

			$contact_form_html = '
				<div class="postsaverplugin-form-section-wrapper">
					<div class="postsaverplugin-form-section-fields-wrapper">
						<div class="postsaverplugin-form-section-fields-indiv-wrapper">
							<label class="postsaverplugin-form-section-fields-label">Dashboard Page <img data-label="settings-dashboard-page" class="postsaverplugin-label-right-question" src="' . POSTSAVER_ROOT_IMG_ICONS_URL . 'question-black.svg" /></label>
							<select class="postsaverplugin-form-section-fields-input-select postsaverplugin-form-classname-class" id="postsaverplugin-settings-dashboard-page">
								<option selected default="" disabled="" value="Choose a Page...">Choose a Page...</option>
								' . $this->allpageshtml . '
							</select>
						</div>
						<div class="postsaverplugin-form-section-fields-indiv-wrapper">
							<label class="postsaverplugin-form-section-fields-label">Main Blog Page <img data-label="settings-blog-page" class="postsaverplugin-label-right-question" src="' . POSTSAVER_ROOT_IMG_ICONS_URL . 'question-black.svg" /></label>
							<select class="postsaverplugin-form-section-fields-input-select postsaverplugin-form-classname-class" id="postsaverplugin-settings-blog-page">
								<option default="" disabled="" value="Choose a Page...">Choose a Page...</option>
								' . $this->allpagesforblogpagehtml . '
							</select>
						</div>
					</div>
					<div class="postsaverplugin-form-section-fields-wrapper">
						<div class="postsaverplugin-form-section-fields-indiv-wrapper">
							<label class="postsaverplugin-form-section-fields-label">Save Your Settings Now!</label>
							<button class="postsaverplugin-form-section-submit-button" id="postsaverplugin-form-section-save-general-settings-button">Save Settings</button>
							<div class="postsaverplugin-spinner"></div>
		 					<div class="postsaverplugin-response-div-actual-container">
		 						<p class="postsaverplugin-response-div-p"></p>
		 						<img class="postsaverplugin-response-div-img" />
		 					</div>
						</div>
					</div>
				</div>';


			$string1 = '
				<div id="postsaverplugin-display-options-container">
					<p class="postsaverplugin-tab-intro-para">Below you can configure various settings for PostSaver. Hover over the Question Mark icons below for more information about each setting.</p>
					<div class="postsaverplugin-form-wrapper postsaverplugin-form-wrapper-create-users">
						' . $contact_form_html . '
					</div>
				</div>';

			return $string1;
		}
	}
endif;
