<?php
/**
 * Postsaverplugin_Settings_Settings1_Tab Tab - class-admin-settings-libraries-tab-ui.php.
 *
 * @author   Jake Evans
 * @category Admin
 * @package  Includes/Classes
 * @version  1
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Postsaverplugin_Settings_Settings1_Tab', false ) ) :

	/**
	 * Postsaverplugin_Settings_Settings1_Tab Class.
	 */
	class Postsaverplugin_Settings_Settings1_Tab {

		/**
		 * Class Constructor
		 */
		public function __construct() {
			require_once POSTSAVER_CLASS_DIR . 'class-admin-ui-template.php';
			require_once POSTSAVER_CLASS_DIR . 'class-settings-one-form.php';

			// Instantiate the class.
			$this->template = new Postsaverplugin_Admin_UI_Template();
			$this->form     = new Postsaverplugin_Settings1_Form();
			$this->allowed_tags = array();

			// Now calling class functions...
			$this->postsaver_allowed_html();
			$this->output_open_admin_container();
			$this->output_tab_content();
			$this->output_close_admin_container();
			$this->output_admin_template_advert();
		}

		public function postsaver_allowed_html() {

			$this->allowed_tags = array(
				'a' => array(
					'class' => array(),
					'href'  => array(),
					'rel'   => array(),
					'title' => array(),
				),
				'div' => array(
					'class' => array(),
					'id' => array(),
					'title' => array(),
					'style' => array(),
				),
				'em' => array(),
				'h1' => array(),
				'h2' => array(),
				'h3' => array(),
				'h4' => array(),
				'h5' => array(),
				'h6' => array(),
				'i' => array(),
				'img' => array(
					'alt'    => array(),
					'class'  => array(),
					'height' => array(),
					'src'    => array(),
					'width'  => array(),
					'data-label'  => array(),
				),
				'li' => array(
					'class' => array(),
				),
				'ol' => array(
					'class' => array(),
				),
				'p' => array(
					'class' => array(),
				),
				'span' => array(
					'class' => array(),
					'title' => array(),
					'style' => array(),
				),
				'strike' => array(),
				'strong' => array(),
				'ul' => array(
					'class' => array(),
				),
				'select' => array(
					'class' => array(),
					'id' => array(),
				),
				'button' => array(
					'class' => array(),
					'id' => array(),
				),
				'option' => array(
					'data-pageid' => array(),
					'value' => array(),
					'selected' => array(),
				),
				'label' => array(
					'class' => array(),
				),
			);
		}

		/**
		 * Opens the admin container for the tab
		 */
		private function output_open_admin_container() {
			$title    = 'PostSaver General Settings';
			$icon_url = POSTSAVER_ROOT_IMG_URL . 'settings.png';

			$title = sanitize_text_field( $title );
			$iconurl = esc_url_raw( $iconurl );

			$html = $this->template->output_open_admin_container( $title, $icon_url );
			echo wp_kses_post( $html );

		}

		/**
		 * Outputs actual tab contents
		 */
		private function output_tab_content() {
			$html = $this->form->output_settings1_form();
			echo wp_kses( $html, $this->allowed_tags );
		}

		/**
		 * Closes admin container.
		 */
		private function output_close_admin_container() {
			
			$html = $this->template->output_close_admin_container();
			echo wp_kses_post( $html );
		}

		/**
		 * Outputs advertisment area.
		 */
		private function output_admin_template_advert() {
			$html =  $this->template->output_template_advert();
			echo wp_kses_post( $html );
		}


	}
endif;

// Instantiate the class.
$cm = new Postsaverplugin_Settings_Settings1_Tab();
